program SML_Handler;

uses
  Forms,
  SysUtils,
  svrMain in 'svrMain.pas' {frmMain},
  SML_Handler_TLB in 'SML_Handler_TLB.pas',
  svrCOMmain in 'svrCOMmain.pas' {SMLHandler: CoClass},
  svrPageHandler in 'svrPageHandler.pas',
  mleSMLContainer in 'mleSMLContainer.pas',
  dpoEmployee in 'dpoEmployee.pas',
  dpoCustomer in 'dpoCustomer.pas',
  dpoBase in 'dpoBase.pas' {DataObject: TDataModule},
  mleCommon in 'mleCommon.pas',
  usXMLDoc in 'usXMLDoc.pas',
  mleTagResolvers in 'mleTagResolvers.pas',
  UHTTPApp in 'UHTTPApp.pas',
  svrSubmitHandler in 'svrSubmitHandler.pas',
  svrCommon in 'svrCommon.pas',
  mleDataBindings in 'mleDataBindings.pas',
  dpoEvent in 'dpoEvent.pas' {Event: TDataModule},
  mlePropertyInfo in 'mlePropertyInfo.pas',
  mleObjectCache in 'mleObjectCache.pas';

{$R *.TLB}

{$R *.RES}

type
  TExceptionHandler = class
  public
    InExceptionState: Boolean;
    procedure HandleException(Sender: TObject; E: Exception);
  end;

var
  ExceptionHandler: TExceptionHandler;

{ TExceptionHandler }

procedure TExceptionHandler.HandleException(Sender: TObject; E: Exception);
begin
  LogEvent(etError, 1, E.Message);
  InExceptionState := True;
end;

begin
  ExceptionHandler := TExceptionHandler.Create;
  try
    Application.OnException := ExceptionHandler.HandleException;
    Application.Initialize;
    Application.CreateForm(TfrmMain, frmMain);
  Application.CreateForm(TEvent, Event);
  if ExceptionHandler.InExceptionState then Exit;
    Application.Run;
  finally
    ExceptionHandler.Free;
  end;
end.
