unit svrCommon;

interface

type
  TEventType = (etError, etWarning, etInformation, etAuditSuccess, etAuditFailure);

procedure LogEvent(aEventType: TEventType; aEventID: LongWord; aMessage: string);

implementation

uses
  Windows, SvcMgr;

var
  EventLog: TEventLogger;

procedure LogEvent(aEventType: TEventType; aEventID: LongWord; aMessage: string);
var
  EventType: DWORD;
begin
  if not Assigned(EventLog) then
    EventLog := TEventLogger.Create('UWReqHandler');

  EventType := EVENTLOG_SUCCESS;
  case aEventType of
    etError:
      EventType := EVENTLOG_ERROR_TYPE;
    etWarning:
      EventType := EVENTLOG_WARNING_TYPE;
    etInformation:
      EventType := EVENTLOG_INFORMATION_TYPE;
    etAuditSuccess:
      EventType := EVENTLOG_AUDIT_SUCCESS;
    etAuditFailure:
      EventType := EVENTLOG_AUDIT_FAILURE;
  end;
//  aMessage := aMessage + ' ticks: ' + IntToStr(GetTickCount);
  EventLog.LogMessage(aMessage, EventType, 1001, aEventID);
end;

end.
